#!/bin/sh
#Script para cambiar la fecha a archivos.
#Utiliza gtkdialog y touch.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

ARCHIVO=$*

export touch="
<window title=\"Cambiar fechas a archivo\" icon-name=\"gtk-properties\">
  <hbox>
   <vbox>
    <frame Nueva fecha para el archivo seleccionado:>
      <text><label>(Ejemp. formato fecha valido: 20080521, 1998-12-24 13:25)</label></text>
      <entry><variable>NEWDATE</variable></entry>
    </frame>
    <frame Tipo de fecha a cambiar:>
     <hbox>
      
      <checkbox>
         <label>Fecha de ultimo acceso</label>
         <variable>ACCESS</variable>
	 <default>true</default>
      </checkbox>
      
      <checkbox>
         <label>Fecha de ultima modificacion</label>
         <variable>MODIFY</variable>
	 <default>true</default>
      </checkbox>
                     
     </hbox>
    </frame>
     <hbox>
      <button ok></button>
      <button cancel></button>
       <button>
	  <label>Ayuda</label>
          <input file stock=\"gtk-help\"></input>
          <action>Xdialog --title \"Ayuda cambiar fechas a archivo\" --left --msgbox \"TIPOS DE FECHAS EN FICHEROS EN LINUX:\n\nEn Linux exiten 3 tipos de fechas para los archivos:\n * atime: fecha de ltimo acceso de lectura o escritura al archivo,\n * mtime: fecha de la ltima modificacin del archivo,\n * ctime: fecha del ltimo cambio de permisos y otros atributos al archivo.\n\nSin embargo, si se monta un sistema de archivos con la opcin _noatime_ activada\n(como es nuestro caso), har que el sistema omita el cambio de fecha en cada lectura (atime)\nlo que resultar en un acceso de lectura mas rpido. Indirectamente, la fecha _atime_\nno se modificar nunca (aprox.) y ser la de creacin del archivo.\n\nEn Garraxi hemos implementado un sistema para la repeticin de programas de radio\nque informa de la fecha de grabacin del programa. Esta fecha se determina de varias maneras,\nuna de las cuales es la fecha de ultimo acceso del archivo de audio. As que hay que tener en cuenta\neste dato a la hora de cambiar la fecha a un archivo de audio de un programa de radio.\n\nAs, como referencia utilizaremos los siguientes tipos de fechas en los siguientes casos:\n * Ultimo acceso (atime): como fecha de creacin del archivo (fecha original del archivo, fija,\n      no cambiarla en archivos creados en Garraxi).\n * Ultima modificacin (mtime): como fecha modificable del archivo (fecha cambiable para lo que sea).\n * ctime: esta fecha se cambia al cambiar los permisos/owner, cosa que se hace cuando\n      un admin protege los archivos.\n\nMas informacin en la Ayuda de Garraxi, en el documento notas/info-software-garraxi3.txt\" 0 0</action>
          </button>
     </hbox>
   </vbox>
  </hbox>
</window>"

I=$IFS; IFS=""
 for STATEMENTS in  $(gtkdialog --program=touch --center); do
   eval $STATEMENTS
 done
IFS=$I

if [ "$NEWDATE" = "" ] || [ "$EXIT" = "abort" ] || [ "$EXIT" = "Cancel" ]; then
 exit
else
 
  if [ "$ACCESS" = "true" ]; then
        ACCESS2=`echo -n "-a"`
  else
        ACCESS2=""
  fi
 
  if [ "$MODIFY" = "true" ]; then
        MODIFY2=`echo -n "-m"`
  else
        MODIFY2=""
  fi 
 
 # 2>&1 es redireccionar staderr a stadout, para que le entre por el pipe a Xdialog.
 touch -c "$ACCESS2" "$MODIFY2" -d "$NEWDATE" "$ARCHIVO" 2>&1 | \
    Xdialog --title "Cambiar fechas a archivo" --no-cancel \
    --backtitle "Mensajes que devuelve al cambiar la fecha\n(si no aparece nada ha sido un exito !!)" \
    --tailbox "-" 10 50

fi

exit

